"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var impl = require("../impl");
var AudioNode = require("./AudioNode");

var AnalyserNode = function (_AudioNode) {
  _inherits(AnalyserNode, _AudioNode);

  function AnalyserNode(context, opts) {
    _classCallCheck(this, AnalyserNode);

    var _this = _possibleConstructorReturn(this, (AnalyserNode.__proto__ || Object.getPrototypeOf(AnalyserNode)).call(this, context));

    _this._impl = new impl.AnalyserNode(context._impl, opts);
    return _this;
  }

  _createClass(AnalyserNode, [{
    key: "getFloatFrequencyData",
    value: function getFloatFrequencyData(array) {
      this._impl.getFloatFrequencyData(array);
    }
  }, {
    key: "getByteFrequencyData",
    value: function getByteFrequencyData(array) {
      this._impl.getByteFrequencyData(array);
    }
  }, {
    key: "getFloatTimeDomainData",
    value: function getFloatTimeDomainData(array) {
      this._impl.getFloatTimeDomainData(array);
    }
  }, {
    key: "getByteTimeDomainData",
    value: function getByteTimeDomainData(array) {
      this._impl.getByteTimeDomainData(array);
    }
  }, {
    key: "fftSize",
    get: function get() {
      return this._impl.getFftSize();
    },
    set: function set(value) {
      this._impl.setFftSize(value);
    }
  }, {
    key: "frequencyBinCount",
    get: function get() {
      return this._impl.getFrequencyBinCount();
    }
  }, {
    key: "minDecibels",
    get: function get() {
      return this._impl.getMinDecibels();
    },
    set: function set(value) {
      this._impl.setMinDecibels(value);
    }
  }, {
    key: "maxDecibels",
    get: function get() {
      return this._impl.getMaxDecibels();
    },
    set: function set(value) {
      this._impl.setMaxDecibels(value);
    }
  }, {
    key: "smoothingTimeConstant",
    get: function get() {
      return this._impl.getSmoothingTimeConstant();
    },
    set: function set(value) {
      this._impl.setSmoothingTimeConstant(value);
    }
  }]);

  return AnalyserNode;
}(AudioNode);

module.exports = AnalyserNode;