"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var impl = require("../impl");
var AudioNode = require("./AudioNode");
var AudioParam = require("./AudioParam");

var BiquadFilterNode = function (_AudioNode) {
  _inherits(BiquadFilterNode, _AudioNode);

  function BiquadFilterNode(context, opts) {
    _classCallCheck(this, BiquadFilterNode);

    var _this = _possibleConstructorReturn(this, (BiquadFilterNode.__proto__ || Object.getPrototypeOf(BiquadFilterNode)).call(this, context));

    _this._impl = new impl.BiquadFilterNode(context._impl, opts);
    _this._impl.$frequency = new AudioParam(context, _this._impl.getFrequency());
    _this._impl.$detune = new AudioParam(context, _this._impl.getDetune());
    _this._impl.$Q = new AudioParam(context, _this._impl.getQ());
    _this._impl.$gain = new AudioParam(context, _this._impl.getGain());
    return _this;
  }

  _createClass(BiquadFilterNode, [{
    key: "getFrequencyResponse",
    value: function getFrequencyResponse(frequencyHz, magResponse, phaseResponse) {
      this._impl.getFrequencyResponse(frequencyHz, magResponse, phaseResponse);
    }
  }, {
    key: "type",
    get: function get() {
      return this._impl.getType();
    },
    set: function set(value) {
      this._impl.setType(value);
    }
  }, {
    key: "frequency",
    get: function get() {
      return this._impl.$frequency;
    }
  }, {
    key: "detune",
    get: function get() {
      return this._impl.$detune;
    }
  }, {
    key: "Q",
    get: function get() {
      return this._impl.$Q;
    }
  }, {
    key: "gain",
    get: function get() {
      return this._impl.$gain;
    }
  }]);

  return BiquadFilterNode;
}(AudioNode);

module.exports = BiquadFilterNode;