"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var impl = require("../impl");
var AudioNode = require("./AudioNode");
var AudioParam = require("./AudioParam");

var DynamicsCompressorNode = function (_AudioNode) {
  _inherits(DynamicsCompressorNode, _AudioNode);

  function DynamicsCompressorNode(context, opts) {
    _classCallCheck(this, DynamicsCompressorNode);

    var _this = _possibleConstructorReturn(this, (DynamicsCompressorNode.__proto__ || Object.getPrototypeOf(DynamicsCompressorNode)).call(this, context));

    _this._impl = new impl.DynamicsCompressorNode(context._impl, opts);
    _this._impl.$threshold = new AudioParam(context, _this._impl.getThreshold());
    _this._impl.$knee = new AudioParam(context, _this._impl.getKnee());
    _this._impl.$ratio = new AudioParam(context, _this._impl.getRatio());
    _this._impl.$attack = new AudioParam(context, _this._impl.getAttack());
    _this._impl.$release = new AudioParam(context, _this._impl.getRelease());
    return _this;
  }

  _createClass(DynamicsCompressorNode, [{
    key: "threshold",
    get: function get() {
      return this._impl.$threshold;
    }
  }, {
    key: "knee",
    get: function get() {
      return this._impl.$knee;
    }
  }, {
    key: "ratio",
    get: function get() {
      return this._impl.$ratio;
    }
  }, {
    key: "reduction",
    get: function get() {
      return this._impl.getReduction();
    }
  }, {
    key: "attack",
    get: function get() {
      return this._impl.$attack;
    }
  }, {
    key: "release",
    get: function get() {
      return this._impl.$release;
    }
  }]);

  return DynamicsCompressorNode;
}(AudioNode);

module.exports = DynamicsCompressorNode;