"use strict";

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var nmap = require("nmap");

/**
 * AudioData is struct like AudioBuffer.
 * This instance has no methods.
 * The channel data of this instance are taken via property accessor.
 * @prop {number}         numberOfChannels
 * @prop {number}         length
 * @prop {number}         sampleRate
 * @prop {Float32Array[]} channelData
 */

var AudioData =
/**
 * @param {number} numberOfChannels
 * @param {number} length
 * @param {number} sampleRate
 */
function AudioData(numberOfChannels, length, sampleRate) {
  var _this = this;

  _classCallCheck(this, AudioData);

  this.numberOfChannels = numberOfChannels | 0;
  this.length = length | 0;
  this.sampleRate = sampleRate | 0;
  this.channelData = nmap(this.numberOfChannels, function () {
    return new Float32Array(_this.length);
  });
};

module.exports = AudioData;