"use strict";

var ChannelMergerNodeDSP = {
  dspProcess: function dspProcess() {
    var outputBus = this.outputs[0].bus;
    var inputBuses = this.inputs.map(function (input) {
      return input.bus;
    });
    var allSilent = inputBuses.every(function (inputBus) {
      return inputBus.isSilent;
    });

    outputBus.zeros();

    if (!allSilent) {
      var outputChannelData = outputBus.getMutableData();

      for (var i = 0, imax = inputBuses.length; i < imax; i++) {
        outputChannelData[i].set(inputBuses[i].getChannelData()[0]);
      }
    }
  }
};

module.exports = ChannelMergerNodeDSP;