"use strict";

var ChannelSplitterNodeDSP = {
  dspProcess: function dspProcess() {
    var inputBus = this.inputs[0].bus;
    var outputs = this.outputs;

    if (inputBus.isSilent) {
      for (var i = 0, imax = outputs.length; i < imax; i++) {
        outputs[i].bus.zeros();
      }
    } else {
      var inputChannelData = inputBus.getChannelData();

      for (var _i = 0, _imax = outputs.length; _i < _imax; _i++) {
        var outputBus = outputs[_i].bus;

        if (inputChannelData[_i]) {
          outputBus.getMutableData()[0].set(inputChannelData[_i]);
        } else {
          outputBus.zeros();
        }
      }
    }
  }
};

module.exports = ChannelSplitterNodeDSP;