"use strict";

/**
 * @param {number|string} str
 * @return {number}
 */

function toAudioTime(str) {
  if (Number.isFinite(+str)) {
    return Math.max(0, +str);
  }

  var matched = ("" + str).match(/^(?:(\d\d+):)?(\d\d?):(\d\d?(?:\.\d+)?)$/);

  if (matched) {
    var hours = +matched[1] | 0;
    var minutes = +matched[2];
    var seconds = +matched[3];

    return hours * 3600 + minutes * 60 + seconds;
  }

  return 0;
}

module.exports = toAudioTime;